#include "lcard_ad.h"
#include "dma32.h"
#pragma hdrstop

WORD *PLinearIn;
WORD *PPhysicalIn;

WORD *PLinearOut;
WORD *PPhysicalOut;

WORD WINAPI _export AllocateBuffer(WORD type, WORD mode)
{
    if(type)
    {
      ALLOCATEBUFFER(128*1024,&PLinearIn,&PPhysicalIn);
      if(!PLinearIn) return 255;
    }
    else
    {
      ALLOCATEBUFFER(128*1024,&PLinearOut,&PPhysicalOut);
      if(!PLinearOut) return 255;
    }
    return mode;
}

WORD WINAPI _export FreeBuffer(WORD type, WORD mode)
{
   if(type) FREEBUFFER(PLinearIn);
   else FREEBUFFER(PLinearOut);
   return mode;
}

WORD WINAPI _export DmaOff(WORD mode)
{
   DMA_OFF(); return mode;
}

WORD WINAPI _export AllocDmaOne(WORD BufLen, WORD CHN, WORD Rate, WORD mode)
{
    DMAONE(PPhysicalIn,BufLen,CHN,Rate,mode); return mode;
}

WORD WINAPI _export AllocDmaAll(WORD BufLen, WORD *CH, WORD CHN, WORD Rate, WORD mode)
{
    DMAALL(PPhysicalIn,BufLen,CH,CHN,Rate,mode); return mode;
}

WORD WINAPI _export AllocDmaDac (WORD BufLen, WORD *CH, WORD CHN, WORD Rate, WORD mode,
                              WORD *BufDac, WORD DacLen, WORD NDac )
{
    for(int j=0;j<DacLen;j++) PLinearOut[j]=BufDac[j];
    DMA_ALL_DA(PPhysicalIn, BufLen, CH, CHN, Rate, mode, PPhysicalOut, DacLen, mode, NDac);
    return mode;
}

WORD WINAPI _export AllocDacOne(WORD *BufDac, WORD BufLen, WORD Rate, WORD NDac, WORD mode)
{
    for(WORD j=0;j<BufLen;j++) PLinearOut[j]=BufDac[j];
    SET_DA_NUMBER(1,NDac);
    DADMASTREAM(PPhysicalOut, BufLen, Rate, mode);
    return mode;
}

WORD WINAPI _export WaitDma(WORD mode, WORD sleep)
{
    if(mode) return mode;
    while(DMA_COUNTER_IN()!=0xFFFF)
    {
        WORD gg1,gg2,gg3;
        gg1=DMA_COUNTER_IN();
        gg2=DMA_COUNTER_OUT();
        Sleep(sleep);
        gg3=DMA_COUNTER_IN();
        if(gg1==gg3) OUT_BYTE(0xD4, 5);
        gg3=DMA_COUNTER_OUT();
        if(gg2==gg3) OUT_BYTE(0xD4, 6);
    };
    return mode;
}

WORD WINAPI _export WaitSingleDma( WORD mode)
{
    if(mode) return mode;
    while(!DMA_TEST());
    return mode;
}

WORD WINAPI _export WaitDma1(WORD BufLen, WORD mode)
{
    if(!mode) return mode; while((DMA_COUNTER_IN())>BufLen); return mode;
}

WORD WINAPI _export WaitDma2(WORD BufLen, WORD mode)
{
    if(!mode) return mode; while((DMA_COUNTER_IN())<BufLen); return mode;
}

WORD WINAPI _export CopyFromBuffer(WORD *Data, WORD BufLen, WORD mode)
{
    WORD j,i;
    j=0;
    if((WORD(DMA_COUNTER_IN()+1))>BufLen) {j=BufLen;}
    for(i=0;i<BufLen;i++){ WORD t=i+j; Data[i]=PLinearIn[t]; }
    return mode;
}


WORD WINAPI _export CopyToBuffer(WORD *Data, WORD BufLen, WORD mode)
{
    WORD j,i;
    j=0;
    if((WORD(DMA_COUNTER_OUT()+1))>BufLen) {j=BufLen;}
    for(i=0;i<BufLen;i++){ WORD t=i+j; PLinearOut[t]=Data[i]; }
    return mode;
}


BOOL WINAPI DllEntryPoint(HINSTANCE /*hDLLInst*/, DWORD fdwReason, LPVOID /*lpvReserved*/)
{
  switch (fdwReason)
  {
    case DLL_PROCESS_ATTACH:
      break;

    case DLL_PROCESS_DETACH:
      break;

    case DLL_THREAD_ATTACH:
      break;

    case DLL_THREAD_DETACH:
      break;
  }
  return TRUE;
}

